<?php






class blocklistrbldns
  {
    private $maxscore        = 5;
    private $cacheenabled    = 0;

    public function blacklistrbldns()
      {
        $this->rbllist = dirname(__FILE__).'/rbldns.list';
        $this->ip      = $this->getUserIP();
        $this->loaddata();
      }
    public function loaddata()
      {
        $this->ip  = $this->getUserIP();
        $this->rip = $this->ReverseIp();
        $this->IpVersion = $this->getIpVersion();
      }

    public function cache()
      {
        # currently not aviable
        return(0);
      }

    public function queryBlacklists()
      {
        $this->score       = 0;
        $block             = 0;
        $this->matchs      = array();
        $this->message     = array();
        $blacklists  = $this->getBlacklistList();
        $blcounts    = count($blacklists);
        if($blcounts >= 1)
          {
            foreach($blacklists as $name => $value)
              {
                if($this->checkAgainstBlacklist($value['rbldns']) !== 0)
                  {
                    $this->message[$name] = str_ireplace('(IP)', $this->ip, $blacklists[$name]['url'], $this->gmessage);
                    $this->matchs[$name]  = $name;
                    $this->score          = $this->score + $value['score'];
                  }
                if($this->score >= $this->maxscore)
                  {
                    $block   = 1;
                    break;
                  }
              }
          }
        else
          {
            $block = 0;
            $matchs[] = 0;
            # no Blacklists active
          }
        return($block);
      }

    public function getmessage()
      {
        return($this->message);
      }


    public function getBlacklistList()
      {
        if(!isset($this->rbllist))
          {
            die("Konnte rblliste nicht finden:\n".$this->rbllist);
          }
        if((file_exists($rbllist)) && (filesize($rbllist) >= 5))
           {
              $blacklists = unserialize(file_get_contents($rbllist));
           }
        return($blacklists);
      }

    public function checkAgainstBlacklist($blacklist)
      {
        $listed = dns_get_record($this->rip.'.'.$blacklist, DNS_A);
        if(!isset($listed[0]))
          {
            $block = 0;
          }
        elseif(isset($listed[0]['ip']))
          {
            $block = 1;
          }
        return($block);
      }


    public function getIpVersion()
      {
        $version = 0;
        if(filter_var($this->ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4) !== FALSE)
          {
            $version = 4;
          }
        elseif(filter_var($this->ip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6) !== FALSE)
          {
            $version = 6;
          }
        $this->IpVersion = $version;
        return($version);
      }


    public function ReverseIp()
      {
        # implode is slower
        # $rip = implode('.', array_reverse(explode ('.', $ip )))
        $IpVersion = $this->getIpVersion($this->ip);
        if($IpVersion == 4)
          {
            $ip1 = explode('.', $this->ip);
            $rip = $ip1[3].'.'.$ip1[2].'.'.$ip1[1].'.'.$ip1[0];
          }
        elseif($IpVersion == 6)
          {
            $ip1 = explode(':', $this->ip);
            $rip = $ip1[4].':'.$ip1[3].':'.$ip1[2].':'.$ip1[1].':'.$ip1[0];
          }
        else
          {
            $rip = 0;
          }
        return($rip);
      }

    public function getUserIP()
      {
        $ip = array ();
        foreach(array('HTTP_CF_CONNECTING_IP', 'HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_X_FORWARDED', 'HTTP_X_CLUSTER_CLIENT_IP', 'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'REMOTE_ADDR') as $key)
          {
             if(array_key_exists($key, $_SERVER) === true)
               {
                  foreach(explode(',', $_SERVER[$key]) as $visitors_ip)
                    {
                      $ip[] = str_replace(' ', '', $visitors_ip);
                    }
               }
          }
    // If for some strange reason we don't get an IP we return imemdiately with 0.0.0.0
        if(empty($ip))
          {
            $ip = 0;
          }
        else
          {
            $ips = array_values(array_unique($ip));
            $ip  = $ip[0];
          }
        return($ip);
      }

  }

